# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt

import grok
import zope.component
import zope.dublincore.interfaces

import gocept.directory.container
import gocept.directory.interfaces


class Customers(gocept.directory.container.Container):

    grok.implements(gocept.directory.interfaces.ICustomers)


grok.templatedir('containertemplates')

class Index(gocept.directory.container.ContainerView):
    pass


@grok.subscribe(Customers, grok.IObjectAddedEvent)
def set_title(customers, event):
    dc = zope.dublincore.interfaces.IDCDescriptiveProperties(customers)
    dc.title = u'Customers'


class ImportCustomers(grok.XMLRPC):

    grok.context(gocept.directory.interfaces.IDirectory)

    def import_customers(self, data):
        customers = zope.component.getUtility(
            gocept.directory.interfaces.ICustomers)
        for customer_data in data:
            cid = str(customer_data['id'])
            customer = customers.get(cid)
            if customer is None:
                customer = customers[cid] = (
                    gocept.directory.customer.Customer(cid))
            title = customer_data['title']
            if customer.title != title:
                customer.title = title
        return True
