# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: person.py 14316 2009-01-23 15:12:55Z zagy $

import grok

import gocept.directory.form
import gocept.directory.interfaces
import gocept.reference


class Person(grok.Model):

    grok.implements(gocept.directory.interfaces.IPerson)

    unixaccount = gocept.reference.Reference(ensure_integrity=True)

    title = u''

    def __init__(self, first_name=u'', last_name=u''):
        self.first_name = first_name
        self.last_name = last_name
        self.unixaccount = None


class Index(gocept.directory.form.BasicEditForm):
    pass


@grok.implementer(gocept.directory.interfaces.ITitle)
def persontitle(person):
    return "%s, %s" % (person.last_name, person.first_name)


class PersonGECOS(grok.Adapter):

    grok.implements(gocept.directory.interfaces.IGECOS)

    @property
    def fullname(self):
        return "%s %s" % (self.context.first_name, self.context.last_name)


@grok.implementer(gocept.directory.interfaces.IUnixAccount)
def unixaccount(person):
    return person.unixaccount
